<app-content-layout>
  <mat-drawer-container class="services-container">
    <mat-drawer mode="side" opened>
      <app-services-sidenav></app-services-sidenav>
    </mat-drawer>
    <mat-drawer-content>
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <div class="inner-navigation">
              <h3 class="heading-services d-inline-block">Services and APi</h3>
              <button class="ml-4" [routerLink]="['/services-create']" mat-mini-fab color="primary"
                aria-label="Example icon button with a menu icon">
                <mat-icon>add</mat-icon>
              </button>
            </div>
          </div>
          <div class="col-12">
            <div class="mat-elevation-z8">

              <table mat-table [dataSource]="dataSource.data" multiTemplateDataRows class="mat-elevation-z8">
                
                    <!-- ID Column -->
                    <ng-container matColumnDef="name">
                      <th mat-header-cell *matHeaderCellDef >Service Name</th>
                      <td mat-cell *matCellDef="let row">
                        <a href="javascript:void(0);" [routerLink]="['/service-update' ,row.srv_id]">
                          {{row.name}} 
                        </a>
                      </td>
                    </ng-container>
                
                    <!-- Progress Column -->
                    <ng-container matColumnDef="port">
                      <th mat-header-cell *matHeaderCellDef > Hostname </th>
                      <td mat-cell *matCellDef="let row"> {{row.hostname}} </td>
                    </ng-container>
                
                    <!-- Name Column -->
                    <ng-container matColumnDef="hostname">
                      <th mat-header-cell *matHeaderCellDef > Port </th>
                      <td mat-cell *matCellDef="let row"> {{row.port}} </td>
                    </ng-container>
                
                    <!-- Color Column -->
                    <ng-container matColumnDef="title">
                      <th mat-header-cell *matHeaderCellDef > Title </th>
                      <td mat-cell *matCellDef="let row"> {{row.title}} </td>
                    </ng-container>
                    
                    <!-- Color Column -->
                    <ng-container matColumnDef="type">
                      <th mat-header-cell *matHeaderCellDef > Type </th>
                      <td mat-cell *matCellDef="let row"> {{row.type}} </td>
                    </ng-container>

                    <!-- Color Column -->
                    <ng-container matColumnDef="visibility">
                      <th mat-header-cell *matHeaderCellDef > Visibility </th>
                      <td mat-cell *matCellDef="let row"> {{row.visibility}} </td>
                    </ng-container>

                    <!-- Color Column -->
                    <ng-container matColumnDef="lifecycle">
                      <th mat-header-cell *matHeaderCellDef > Lifecycle </th>
                      <td class="position-relative" mat-cell *matCellDef="let row">
                         {{row.lifecycle}}
                         <ul class="table-actions23 tab-btns"  style="display: none;">
                         <li>
                           <a  mat-raised-button
                             href="javascript:void(0);"
                             title="Delete"
                           >
                             <mat-icon>delete_forever</mat-icon>
                           </a>
                         </li>
                       </ul>
                      </td>
                    </ng-container>


                <!-- Expanded Content Column - The detail row is made up of this one column that spans across all columns -->
                <ng-container matColumnDef="expandedDetail">
                  <td mat-cell *matCellDef="let element" [attr.colspan]="columnsToDisplay.length">
                    <div class="example-element-detail"
                      [@detailExpand]="element == expandedElement ? 'expanded' : 'collapsed'">

                      <table mat-table [dataSource]="dataSourceV.data" matSort class="service-version-table">

                        <ng-container matColumnDef="version_id">
                          <th mat-header-cell *matHeaderCellDef> Version Id </th>
                          <td mat-cell *matCellDef="let element"> {{element['version_id']}} </td>
                        </ng-container>
                        <ng-container matColumnDef="srv_id">
                          <th mat-header-cell *matHeaderCellDef> Service Id </th>
                          <td mat-cell *matCellDef="let element"> {{element['srv_id']}} </td>
                        </ng-container>
                        <ng-container matColumnDef="description">
                          <th mat-header-cell *matHeaderCellDef> Description </th>
                          <td mat-cell *matCellDef="let element"> {{element.description}}</td>
                        </ng-container>
                        <ng-container matColumnDef="container_reg_uri">
                          <th mat-header-cell *matHeaderCellDef> Container Registry URI </th>
                          <td class="position-relative" mat-cell *matCellDef="let element"> {{element['container_reg_uri']}} 
                            <ul class="table-actions23 tab-btns"  style="display: none;">
                              <li> <a  mat-raised-button href="javascript:void(0);"
                                      [routerLink]="['/']"
                                      title="Edit">
                                <mat-icon>create</mat-icon>
                              </a> 
                             </li>
                              <li>
                                <a  mat-raised-button
                                  href="javascript:void(0);"
                                  title="Delete"
                                  (click)="deleteVersion(element['version_id'],element['srv_id'])"
                                >
                                  <mat-icon>delete_forever</mat-icon>
                                </a>
                              </li>
                            </ul>
                          </td>
                        </ng-container>

                        <ng-container matColumnDef="add-version">
                          <td mat-footer-cell *matFooterCellDef colspan="3">
                            <span class="add-version">Add New Version</span>
                            <button (click)="openAddVerModal(element['srv_id'])" class="ml-2" mat-mini-fab color="primary"
                            aria-label="Example icon button with a menu icon">
                            <mat-icon>add</mat-icon>
                          </button>
                          </td>
                        </ng-container>
                        
                        
                        
                        <tr mat-header-row class="inner-table-header" *matHeaderRowDef="versionColumns"></tr>
                        <tr class="inner-table-row" mat-row *matRowDef="let element; columns: versionColumns;"></tr>
                        <tr mat-footer-row *matFooterRowDef="['add-version']" class="example-second-footer-row"></tr>

                        <!-- Row shown when there is no matching data. -->
                        <tr class="mat-row" *matNoDataRow>
                          <!-- <td class="mat-cell" colspan="4">No data matching the filter "{{input.value}}"</td> -->
                        </tr>
                      </table>
                    </div>
                  </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedData"></tr>
                <tr mat-row *matRowDef="let element; columns: displayedData;" class="example-element-row"
                  [class.example-expanded-row]="expandedElement === element"
                  (click)="expandedElement = expandedElement === element ? null : element; getVersions(element.srv_id)">
                </tr>
                <tr mat-row *matRowDef="let row; columns: ['expandedDetail']" class="example-detail-row"></tr>
              </table>


              <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]"></mat-paginator>
            </div>
          </div>
        </div>
      </div>
    </mat-drawer-content>
  </mat-drawer-container>
</app-content-layout>

<ng-template #addVersionModal>
  <h2 matDialogTitle>Add Service Version</h2>
  <hr>
  <form class="example-form" [formGroup]="serviceVersionForm" (ngSubmit)="onSubmit()">
  <mat-card class="custom-card-styling mb-4">
    <div class="row form-group">
      <div class="col-lg-6">
        <mat-form-field class="example-full-width w-100">
          <mat-label>Version ID</mat-label>
          <input matInput placeholder="12345" value="" formControlName="version_id">
        </mat-form-field>
      </div>
      <div class="col-6">
        <mat-form-field class="example-full-width w-100">
          <mat-label>Container Registry URI</mat-label>
          <input matInput placeholder="" formControlName="container_reg_uri">
        </mat-form-field>
      </div>
    </div>
    <div class="row">
      <div class="col-lg-12">
        <mat-form-field class="example-full-width w-100">
          <mat-label>Description</mat-label>
          <input matInput placeholder="" value="" formControlName="description">
        </mat-form-field>
      </div>

   
    </div>
  </mat-card>
  
  <mat-dialog-actions align="end">
    <button mat-flat-button matDialogClose="no">No</button>
    <button type="submit" mat-flat-button color="primary" matDialogClose="no">Yes</button>
  </mat-dialog-actions>
</form>
</ng-template>

